<?php
session_start();
$url_action = (empty($_REQUEST['action'])) ? 'logIn' : $_REQUEST['action'];
 $auth_realm = (isset($auth_realm)) ? $auth_realm : '';
 
if (isset($url_action)) {
     if (is_callable($url_action)) {
         call_user_func($url_action);
     } else {
         echo 'Function does not exist, request terminated';
     };
 };
 
function logIn() {
     global $auth_realm;
 
    if (!isset($_SESSION['username'])) {
         if (!isset($_SESSION['login'])) {
             $_SESSION['login'] = TRUE;
             header('WWW-Authenticate: Basic realm="'.$auth_realm.'"');
             header('HTTP/1.0 401 Unauthorized');
			 echo 	"<head><title>Password Database</title><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />".
					"<link href=\"css/redmond/itpwd.css\" rel=\"stylesheet\" type=\"text/css\"></head>";
			 echo 	"<center><p><table class=\"title\" width=\"726\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">".
					"<tr align=\"center\" valign=\"top\"><td class=\"title\"> &nbsp; Welcome to the Password Database</td>".
					"</tr></table></p>";
             echo 'You must enter a valid login and password';
             echo '<p><a href="?action=logOut">Try again</a></p>';
             exit;
         } else {
             $user = isset($_SERVER['PHP_AUTH_USER']) ? $_SERVER['PHP_AUTH_USER'] : '';
             $password = isset($_SERVER['PHP_AUTH_PW']) ? $_SERVER['PHP_AUTH_PW'] : '';
             $result = authenticate($user, $password);
             if ($result == 0) {
                $_SESSION['username'] = $user;
             } else {
                 session_unset($_SESSION['login']);
                 errMes($result);
                 echo '<p><a href="">Try again</a></p>';
                 exit;
             };
         };
     };
 }
 
function authenticate($user, $password) {
	require_once(dirname(__FILE__) . '/adLDAP/src/adLDAP.php');
	$adldap = new adLDAP();

	if($adldap->authenticate($user,$password)) { 
		$_SESSION['group_arr'] = $adldap->user()->info($user, array('memberof'));
		return 0; 
	}
     else { return 1; };
}
 
function errMes($errno) {
     switch ($errno) {
         case 0:
             break;
         case 1:
			 echo 	"<head><title>Password Database</title><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />".
					"<link href=\"css/redmond/itpwd.css\" rel=\"stylesheet\" type=\"text/css\"></head>";
			 echo 	"<center><p><table class=\"title\" width=\"726\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">".
					"<tr align=\"center\" valign=\"top\"><td class=\"title\"> &nbsp; Welcome to the Password Database</td>".
					"</tr></table></p>";
			 echo 'The username or password you entered is incorrect';
             break;
         default:
             echo 'Unknown error';
     };
 }
 
function logOut() {
 
    session_destroy();
     if (isset($_SESSION['username'])) {
         session_unset($_SESSION['username']);
		echo 	"<head><title>Password Database</title><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />".
				"<link href=\"css/redmond/itpwd.css\" rel=\"stylesheet\" type=\"text/css\"></head>";
		echo 	"<center><p><table class=\"title\" width=\"726\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">".
				"<tr align=\"center\" valign=\"top\"><td class=\"title\"> &nbsp; Password Database</td>".
				"</tr></table></p>";
        echo "You've successfully logged out<br><p><a href=\"?action=logIn\">LogIn</a></p>";
		
     } else {
         header("Location: ?action=logIn", TRUE, 301);
     };
     if (isset($_SESSION['login'])) { session_unset($_SESSION['login']); };
     exit;
 }
 
function acl() {
 
    session_destroy();
     if (isset($_SESSION['username'])) {
         session_unset($_SESSION['username']);
		echo 	"<head><title>Password Database</title><meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />".
				"<link href=\"css/redmond/itpwd.css\" rel=\"stylesheet\" type=\"text/css\"></head>";
		echo 	"<center><p><table class=\"title\" width=\"726\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">".
				"<tr align=\"center\" valign=\"top\"><td class=\"title\"> &nbsp; Welcome to the Password Database</td>".
				"</tr></table></p>";
        echo "Your user account does not belong to a security group to access this website.<br>Please contact the administrator to update your security rights<br><p><a href=\"?action=logIn\">LogIn</a></p>";
		
     } else {
         header("Location: ?action=logIn", TRUE, 301);
     };
     if (isset($_SESSION['login'])) { session_unset($_SESSION['login']); };
     exit;
 }
?> 
