<?php
/////////////////////////
// Variable definition //
/////////////////////////
$auth_realm = 'ADDOMAINNAME'; // Active Directory domain name
$text_search = '' ; // Do not update this variable
$filter = ''; // Do not update this variable
$search_string = ''; // Do not update this variable
$sec_fil = "./@.security"; // Configuration file with the groups authorized to login on the password database
$sec_arr = file($sec_fil); // Read the security file and put each line in an array
natsort($sec_arr); //sort the array
$sec_arr_short = array();
foreach ($sec_arr as $sec_arr_fullcn)
{
	$sec_arr_shortcn = explode(",",$sec_arr_fullcn);
	array_push($sec_arr_short, $sec_arr_shortcn[0]);
}
$section_fil = "./section.cfg"; // Configuration file with the section types for all password entries
$section_arr = file($section_fil); // Read the section file and put each line in an array
$url = "http" . ((!empty($_SERVER['HTTPS'])) ? "s" : "") . "://".$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']; // Current url

// Active Directory authentication using adLDAP (http://adldap.sourceforge.net/)
require_once 'auth.php';
require_once(dirname(__FILE__) . '/adLDAP/src/adLDAP.php');
// Get the current logged in username and his group membership
$username = $_SESSION['username'];
$groupArray = $_SESSION['group_arr'];
$_SESSION['fromMain'] = "true"; //Protect the page api.php from loading directly instead of loading from index.php

// Parse the groups in the security file
foreach ($sec_arr as $secgroup) {
        $sec_arr_trim[] = trim($secgroup);
}
$acl = array();
$acl = array_intersect($groupArray[0]["memberof"], $sec_arr_trim);
if (empty($acl)){
?>
<script type="text/javascript">
window.open('index.php?action=acl','_self')
</script>
<?php
        exit;
}
else {
        foreach ($acl as $group_cn) {
                $global_group_cn1 = explode(",",$group_cn);
                $global_group_cn[] = $global_group_cn1[0];
        }
        $groupIDStr = implode(',',$global_group_cn);
}
?>



<!DOCTYPE html>
<html>
<head>
<title>Password Database</title>
<meta name='author' content='Nicolas HAHANG' />
<meta name='copyright' content='2012 - Nicolas HAHANG' />
<meta charset="UTF-8">

<link rel="stylesheet" type="text/css" href="css/redmond/itpwd.css">
<link href="css/redmond/jquery-ui-1.9.0.custom.css" rel="stylesheet">
<script src="js/jquery-1.8.2.js"></script>
<script src="js/jquery-ui-1.9.0.custom.js"></script>


<script type="text/javascript">
	var pDlg;
	// Tab initialization
	$(document).ready(function(){
		// Set up a listener so that when anything with a class of 'tab' 
		// is clicked, this function is run.
		$('.tab').click(function () {
			// Remove the 'active' class from the active tab.
			$('#tabs_container > .tabs > li.active').removeClass('active');
			// Add the 'active' class to the clicked tab.
			$(this).parent().addClass('active');
			// Remove the 'tab_contents_active' class from the visible tab contents.
			$('#tabs_container > .tab_contents_container > div.tab_contents_active').removeClass('tab_contents_active');
			// Add the 'tab_contents_active' class to the associated tab contents.
			$(this.rel).addClass('tab_contents_active');
		});
	});

	// JQuery Dialog box definition
        function OpenPWDDialog(iID,qTYPE,uREADER)
        {
		$('#MsgBox').empty();
        	pDlg = jQuery('#MsgBox');

		switch(qTYPE)
		{
		// View Dialog box
		case 0:
			pDlg.dialog
			({
				modal: true,
				width:550,
				height:600,
				title: "View a password entry",
				buttons:
				{
					Close: function()
					{
						$(this).dialog("close");
					}
				}
			});
			SetHistory(4,iID,uREADER);
			GetData(iID,qTYPE,uREADER);
			break;
		// Edit Dialog box
		case 1:
                        pDlg.dialog
                        ({
                                modal: true,
                                width:500,
                                height:600,
				title: "Edit a password entry",
                                buttons:
                                {
                                        Cancel: function()
                                        {
                                                $(this).dialog("close");
                                        },

                                        Apply: function()
                                        {
						var PWD_edit_type = document.getElementById("updated_type").value;
						var PWD_edit_username = document.getElementById("username").value;
						var PWD_edit_password = document.getElementById("password").value;
						var PWD_edit_comment = document.getElementById("comment").value;
						var PWD_edit_url = document.getElementById("url").value;
						var PWD_edit_acl = $('input:checkbox:checked.acl_chkbox').map(function () {
                                                        return this.value;
                                                }).get().join(' , ');
						EditData(iID,3,PWD_edit_type,PWD_edit_username,PWD_edit_password,PWD_edit_comment,PWD_edit_url,PWD_edit_acl);
                                                $(this).dialog("close");

						$("tr[PWD_ID_TAG] td[PWDfield]").each(function(){
							if ($(this).parent().attr('PWD_ID_TAG') == iID)
							{
								switch($(this).attr('PWDfield'))
								{
									case 'type':
										$(this).text(PWD_edit_type);
										break;
									case 'comment':
										$(this).text(PWD_edit_comment);
										break;
									case 'username':
										$(this).text(PWD_edit_username);
										break;
									case 'url':
										$(this).text(PWD_edit_url);
										break;
								}
							}
						});

                                        }
                                }
                        });
                        GetData(iID,qTYPE,uREADER);
			break;
		// Create Dialog box
		case 2:
                        pDlg.dialog
                        ({
                                modal: true,
                                width:500,
                                height:600,
				title: "Create a new password entry",
                                buttons:
                                {
                                        Cancel: function()
                                        {
                                                $(this).dialog("close");
                                        },

                                        Create: function()
                                        {
						var PWD_new_type = document.getElementById("new_type").value;
						var PWD_new_username = document.getElementById("username").value;
						var PWD_new_password = document.getElementById("password").value;
						var PWD_new_comment = document.getElementById("comment").value;
						var PWD_new_url = document.getElementById("url").value;
						var PWD_new_acl = $('input:checkbox:checked.acl_chkbox').map(function () {
                                                        return this.value;
                                                }).get().join(' , ');
						NewData(5,PWD_new_type,PWD_new_username,PWD_new_password,PWD_new_comment,PWD_new_url,PWD_new_acl);
						// Ajax call to retrieve the password entry ID
						$.ajaxSetup ({
							cache: false
						});
						$.ajax
						({
							url: 'api.php',                  //the script to call to get data
							async: false,
							dataType: 'json',                //data format
							data: "query=-1",
							success: function(rows)          //on recieve of reply
							{
								var row = rows[0];
								var iID = row[0];
								var PWD_new_type = row[1];
								var PWD_new_username = row[2];
								var PWD_new_comment = row[4];
								var PWD_new_url = row[5];

								var PWD_NewContent = "<tr PWD_ID_TAG=\"" + iID + "\">" +
								"<TD id='styledpx' PWDfield='type' class='PWDTYPE' align='center'>" + PWD_new_type + "</TD>" +
								"<TD id='styled' PWDfield='comment' class='PWDTOSEARCH'>" + PWD_new_comment + "</TD>" +
								"<TD PWDfield='username' class='PWDTOSEARCH'>" + PWD_new_username + "</TD>" +
								"<TD class='icon'><input alt='Edit' type='image' src='js/images/PWD_edit.png' onClick='OpenPWDDialog(\"" + iID + "\",1,\"" + uREADER + "\")'></TD>" +
								"<TD class='icon'><input alt='View' type='image' src='js/images/PWD_view.png' onClick='OpenPWDDialog(\"" + iID + "\",0,\"" + uREADER + "\")'></TD>" +
								"<TD id='styled' PWDfield='url' class='PWDTOSEARCH'>" + PWD_new_url + "</TD>" +
								"<TD class='icon'><input alt='Delete' type='image' style='padding:6px;position: relative;' src='js/images/PWD_delete.png' onclick='DeleteData(\"" + iID + "\",6)';></TD></tr>   ";

								$('#tbl-1 > tbody:first').append(PWD_NewContent);

								$("li a").each(function(){
									if ($(this).text() == PWD_new_type) 
									{
										$(this).trigger('click');
									}
								});
								filter_type(PWD_new_type);
								update_rows();
							}
						});
                                                $(this).dialog("close");
                                        }
                                }
                        });
                        
			var PWD_userMembership_grouplist_Arr = new Array;
			var PWD_acllist_Arr = new Array;
			<?php
				for($i=0;$i<count($sec_arr_short); $i++)
				{
					echo "PWD_acllist_Arr[$i]='".$sec_arr_short[$i]."';\n";
				}
				for($i=0;$i<count($global_group_cn); $i++)
				{
					echo "PWD_userMembership_grouplist_Arr[$i]='".strtoupper($global_group_cn[$i])."';\n";
				}
			?>
			var PWD_content = "<div class='datagrid'><table>" +
					"<tr class='alt'><td>Type</td><td><select name='type' id='new_type'>" +
			<?php
			foreach($section_arr as $line_num => $line){
				$line = trim( preg_replace( '/\s+/', ' ', $line ) );
				echo "\"<option value='$line'>$line</option>\"+";
			}
			?> +
			"</td></tr>" +
			"<tr><td>Username</td><td><input name='username' type='text' id='username' class='editfield'></td></tr>" +
			"<tr class='alt'><td>Password</td><td><input name='password' type='text' id='password' class='editfield'></td></tr>" +
			"<tr><td>Comment</td><td><textarea class='editfield' name='comment' type='text' id='comment'></textarea></td></tr>" +
			"<tr class='alt'><td>URL</td><td><textarea class='editfield' name='url' type='text' id='url'></textarea></td></tr>" +
			"<tr><td>ACL</td><td><div class='scroll'>" ;
			var i;
			for(i=0;i<PWD_acllist_Arr.length;i++)
			{
				if($.inArray(PWD_acllist_Arr[i].toUpperCase(),PWD_userMembership_grouplist_Arr)<0)
				{
					PWD_content = PWD_content + "<input type='checkbox' class='acl_chkbox' value='" + PWD_acllist_Arr[i] + "'><font Size=1,5>" + PWD_acllist_Arr[i] + "</font></input><br>";
				}
				else
				{
					PWD_content = PWD_content + "<input type='checkbox' class='acl_chkbox' value='" + PWD_acllist_Arr[i] + "' checked disabled checked='checked'><font Size=1,5>" + PWD_acllist_Arr[i] + "</font></input><br>";
				}
			}
			
			PWD_content = PWD_content + "</div></td></tr></table></div>";
			pDlg.append(PWD_content);

			break;
		}
        }

        function NewData(qTYPE,PWD_edit_type,PWD_edit_username,PWD_edit_password,PWD_edit_comment,PWD_edit_url,PWD_edit_acl)
        {
                $.ajax
                ({
                        url: 'api.php',                  //the script to call to get data
						async: false,
                        dataType: 'json',                //data format
                        data: "query="+ qTYPE + 
				"&type=" + PWD_edit_type + 
				"&username=" + PWD_edit_username + 
				"&password=" + PWD_edit_password + 
				"&comment=" + PWD_edit_comment + 
				"&url=" + PWD_edit_url +
				"&acl=" + PWD_edit_acl
		});
		return true;
	}

        function DeleteData(iID,qTYPE)
        {
                pDlg = jQuery('#MsgBox');
		pDlg.text("Are you sure you want to permanently delete this password entry ?");
		pDlg.dialog
		({
			modal: true,
			width:550,
			height:200,
			title: "Delete a password entry",
			buttons:
			{
				Cancel: function()
				{
					$(this).dialog("close");
				},

				Remove: function()
				{
					$.ajax
					({
						url: 'api.php',
						dataType: 'json',
						data: "query="+ qTYPE + 
							"&pwd_id=" + iID 
					});
					$(this).dialog("close");
					$("tr[PWD_ID_TAG] td[PWDfield]").each(function(){
						if ($(this).parent().attr('PWD_ID_TAG') == iID)
						{
							$(this).parent().remove();
						}
					});
				}
			}
		});
	}

        function EditData(iID,qTYPE,PWD_edit_type,PWD_edit_username,PWD_edit_password,PWD_edit_comment,PWD_edit_url,PWD_edit_acl)
        {
                $.ajax
                ({
                        url: 'api.php',                  //the script to call to get data
                        dataType: 'json',                //data format
                        data: "query="+ qTYPE + 
				"&pwd_id=" + iID + 
				"&type=" + PWD_edit_type + 
				"&username=" + PWD_edit_username + 
				"&password=" + PWD_edit_password + 
				"&comment=" + PWD_edit_comment + 
				"&url=" + PWD_edit_url +
				"&acl=" + PWD_edit_acl
		});
		return true;
	}

	function SetHistory(qTYPE,iID,logonUsername)
	{
                $.ajax
                ({
                        url: 'api.php',                  //the script to call to get data
                        dataType: 'json',                //data format
                        data: "query="+ qTYPE + "&pwd_id=" + iID + "&logonUsername=" + logonUsername
                });
	}

	function GetHistory(PWDrows)
	{
		var PWD_content = "";
		for (var i in PWDrows)
		{
			var row = PWDrows[i];
			var PWD_history_date = "";
			var PWD_history_user = "";
			var PWD_history_date = row[8];
			var PWD_history_user = row[7];
			PWD_content = PWD_content + PWD_history_user + " read this entry on " + PWD_history_date + "<br>";
		}
		return PWD_content;
	}

        function GetData(iID,qTYPE,logonUsername)
        {
		$.ajaxSetup ({ 
   		// Disable caching of AJAX responses 
    			cache: false 
		}); 
                $.ajax
                ({
                        url: 'api.php',                  //the script to call to get data
                        dataType: 'json',                //data format
                        data: "query="+ qTYPE + "&pwd_id=" + iID,
                        success: function(rows)          //on recieve of reply
                        {
				var PWD_content = "";
				var row = "";
				var PWD_type = "";
				var PWD_username = "";
				var PWD_password = "";
				var PWD_url = "";
				var PWD_comment = "";
				var PWD_acl = "";
				row = rows[0];
				PWD_type = row[1];
				PWD_username = row[2];
				PWD_password = row[6];
				PWD_url = row[5];
				PWD_comment = row[4];
				switch(qTYPE)
				{
				// Build View Password entry dialog
				case 0:
					PWD_content = "<div class='datagrid'><table>" +
					"<tr class='alt'><td>Type</td><td>" + PWD_type + "</td></tr>" +
					"<tr><td>Username</td><td>" + PWD_username + "</td></tr>" +
					"<tr class='alt'><td>Password</td><td>" + PWD_password + "</td></tr>" +
					"<tr><td>Comment</td><td>" + PWD_comment + "</td></tr>" +
					"<tr class='alt'><td>URL</td><td>" + PWD_url + "</td></tr></table></div><br>" +
					"<div class='datagrid'><table><TR><td>History</td><td class='alt'>";
					SetHistory(4,iID,logonUsername);
					historyDATA = GetHistory(rows);	
                                	PWD_content = PWD_content + historyDATA + "</td></tr></table></div>";
					pDlg.append(PWD_content);
					break;
				// Build Edit Password entry dialog
				case 1:
					PWD_acl = row[3].toUpperCase();
					var PWD_acldb_Arr = PWD_acl.split(" , ");
					var PWD_acllist_Arr = new Array;
					var PWD_userMembership_grouplist_Arr = new Array;
					<?php
						for($i=0;$i<count($sec_arr_short); $i++)
						{
							echo "PWD_acllist_Arr[$i]='".$sec_arr_short[$i]."';\n";
						}
						for($i=0;$i<count($global_group_cn); $i++)
						{
							echo "PWD_userMembership_grouplist_Arr[$i]='".$global_group_cn[$i]."';\n";
						}
					?>
                                        PWD_content = "<div class='datagrid'><table>" +
							"<tr class='alt'><td>Type</td><td><select name='type' id='updated_type'>" +
							"<option selected value=" + PWD_type + ">" + PWD_type + "</option>" +
							"<option disabled>---------------------</option>" +
					<?php
					foreach($section_arr as $line_num => $line){
						$line = trim( preg_replace( '/\s+/', ' ', $line ) );
						echo "\"<option value='$line'>$line</option>\"+";
					}
					?> +
					"</td></tr>" +
                                        "<tr><td>Username</td><td><input name='username' type='text' class='editfield' id='username' value=" + PWD_username + "></td></tr>" +
                                        "<tr class='alt'><td>Password</td><td><input name='password' class='editfield' type='text' id='password' value=" + PWD_password + "></td></tr>" +
                                        "<tr><td>Comment</td><td><textarea class='editfield' name='comment' type='text' id='comment' value=" + PWD_comment + ">" + PWD_comment + "</textarea></td></tr>" +
                                        "<tr class='alt'><td>URL</td><td><textarea class='editfield' name='url' type='text' id='url' value=" + PWD_url + ">" + PWD_url + "</textarea></td></tr>" +
					"<tr><td>ACL</td><td><div class='scroll'>" ;
					for(i=0;i<PWD_acllist_Arr.length;i++)
					{
						if($.inArray(PWD_acllist_Arr[i].toUpperCase(),PWD_acldb_Arr)<0)
						{
							PWD_content = PWD_content + "<input type='checkbox' class='acl_chkbox' value='" + PWD_acllist_Arr[i] + "'><font Size=1,5>" + PWD_acllist_Arr[i] + "</font></input><br>";
						}
						else
						{
							PWD_content = PWD_content + "<input type='checkbox' class='acl_chkbox' value='" + PWD_acllist_Arr[i] + "' checked='checked'><font Size=1,5>" + PWD_acllist_Arr[i] + "</font></input><br>";
						}
					}
					
					PWD_content = PWD_content + "</div></td></tr></table></div>";
					SetHistory(4,iID,logonUsername);
					pDlg.append(PWD_content);

					$("div.scroll input:checkbox").each(function(){
						if($.inArray($(this).attr("value"),PWD_userMembership_grouplist_Arr)>-1)
						{
							$(this).attr("disabled", true);
						}
					});
					break;
				// Build the main Password table
				case 2:
					var PWD_content = "<div class='datagrid'><TABLE id='tbl-1'>" +
							"<thead><tr>" +
							"<TH class='PWD_type_filtering'><center><font Size=1,5> Type</TH>" +
							"<TH><center><font Size=1,5> Comment</TH>" +
							"<TH><center><font Size=1,5> Username</TH>" +
							"<TH colspan='2'><center><font Size=1,5> Edit / View</TH>" +
							"<TH><center><font Size=1,5> URL</TH>" +
							"<TH><center><font Size=1,5> Delete</TH></tr></thead><tbody id='tbl-1-body'>" ;
					for (var i in rows)
					{
						var row = rows[i];
						var PWD_pwdid = row[0];
						var PWD_type = row[1];
						var PWD_username = row[2];
						var PWD_url = row[5];
						var PWD_comment = row[4];
						var PWD_acl = row[3].toUpperCase();
	                                        var PWD_acldb_Arr = PWD_acl.split(" , ");
						var PWD_userMembership_grouplist_Arr = new Array;
						<?php
							for($i=0;$i<count($global_group_cn); $i++)
							{
								echo "PWD_userMembership_grouplist_Arr[$i]='".strtoupper($global_group_cn[$i])."';\n";
							}
						?>
						var user_PWD_access = false;
						
						for(i=0;i<PWD_acldb_Arr.length;i++)
						{
							if($.inArray(PWD_acldb_Arr[i].toUpperCase(),PWD_userMembership_grouplist_Arr)>=0)
							{
								user_PWD_access = true;
							}
						}
						if (user_PWD_access == true)
						{
							PWD_content = PWD_content + "<tr PWD_ID_TAG=\"" + PWD_pwdid + "\">" +
							"<TD id='styledpx' PWDfield='type' class='PWDTYPE' align='center'>" + PWD_type + "</TD>" +
							"<TD id='styled' PWDfield='comment' class='PWDTOSEARCH'>" + PWD_comment + "</TD>" +
							"<TD PWDfield='username' class='PWDTOSEARCH'>" + PWD_username + "</TD>" +
							"<TD class='icon'><input alt='Edit' type='image' src='js/images/PWD_edit.png' onClick='OpenPWDDialog(\"" + PWD_pwdid + "\",1,\"" + logonUsername + "\")'></TD>" +
							"<TD class='icon'><input alt='View' type='image' src='js/images/PWD_view.png' onClick='OpenPWDDialog(\"" + PWD_pwdid + "\",0,\"" + logonUsername + "\")'></TD>" +
							"<TD id='styled' PWDfield='url' class='PWDTOSEARCH'>" + PWD_url + "</TD>" +
							"<TD class='icon'><input alt='Delete' type='image' style='padding:6px;position: relative;' src='js/images/PWD_delete.png' onclick='DeleteData(\"" + PWD_pwdid + "\",6)';></TD></tr>   ";
						}
					}
					PWD_content = PWD_content + "</tbody></table></div>" 
					$(document.body).append(PWD_content);
					update_rows();
					break;
				}
                        }
                });
        }
	
	// Filter Password table with tabs
	function filter_type(filterdata) 
	{
		var filterSTR = filterdata;
		$('tr').show();
		if(filterSTR != '') {
			$('tr td.PWDTYPE').each(function() 
			{
				if ($(this).text() != filterSTR)
				{
					$(this).parent().hide();
				}
			});
		}
	}

	// Function to search password
	function search_PWD()
	{
		var STR_TO_SEARCH = document.getElementById("filter_pattern").value;
                if(STR_TO_SEARCH != '') {
			
			$('#tbl-1-body tr').each(function(){ $(this).hide()});
			
                        $('#tbl-1-body tr>td').each(function()
                        {
				var pRow=$(this);
				var stringFULL = $(this).text();
                                if (stringFULL.toUpperCase().indexOf(STR_TO_SEARCH.toUpperCase()) != -1)
                                {
					pRow.parent().show();
				}
                        });
                }
                update_rows();
	}

	function update_rows()
	{
		$("tbody tr:visible:even").css("background-color", "#E1EEf4");
		$("tbody tr:visible:odd").css("background-color", "#FFFFFF");
	}


</script>
</head>
<body>

<div class="background">
	<div class="top">
		<div class="rightTitle"> Password Database</div>
		<br /><br /><br /><br />
		<?php
			echo "<div class=\"right\">Welcome $username (member of $groupIDStr)   ";
			echo "<a href=\"?action=logOut\"><img src=\"js/images/PWD_log_out.png\" border=0 alt=\"Logout\" style=\"vertical-align:middle\"></a></div><br />";
		?>
		<br />
		<div class="right">
			<input type="text" id="filter_pattern" onKeydown="Javascript: if (event.keyCode==13) search_PWD();" />
			<button onClick="search_PWD();update_rows();">Search</button>
		</div>
	</div>
	<br>
	<div id="MsgBox"></div>
	<br><br><br><br><br><br><br><br><br>

	<div id="tabs_container">
		<!-- These are the tabs -->
		<ul class="tabs">
			<li class="active"><a href="#" onClick="filter_type('')" class="tab">All</a></li>
			<?php
			// Create a tab for each section found in the configuration file
			foreach($section_arr as $line_num => $line){
				$line = trim( preg_replace( '/\s+/', ' ', $line ) );
				echo "<li><a href=\"#\" onClick=\"filter_type('$line')\" class=\"tab\">$line</a></li>";
			}
			if (strpos($groupIDStr, "groupITPWD-adm")) {
				echo "<li><a class=\"tab\" href=\"section.php\"><img src=\"js/images/PWD_setting.png\" border=0 alt=\"Setting\" style=\"vertical-align:middle\"></a></li>";
			}
			?>
		</ul>

		<!-- This is used so the contents don't appear to the 
		   right of the tabs -->
		<div class="clear"></div>

		<!-- This is a div that hold all the tabbed contents -->
		<div class="tab_contents_container">

			<script>
				var username = "<?php echo $username ?>";
				GetData('All',2,username);
			</script>

		<button onClick='OpenPWDDialog("NEW",2,"<?php echo $username ?>")'><img src="js/images/PWD_add.png" border=0 style="width:15px;vertical-align:middle;">  Add a new entry</button>
		</div>
	</div>
</div>

</body>
</html>
